------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Brushes;
with Qt4.Fonts;
limited with Qt4.Graphics_Ellipse_Items;
limited with Qt4.Graphics_Items;
limited with Qt4.Graphics_Line_Items;
limited with Qt4.Graphics_Path_Items;
limited with Qt4.Graphics_Polygon_Items;
limited with Qt4.Graphics_Rect_Items;
limited with Qt4.Graphics_Simple_Text_Items;
limited with Qt4.Graphics_Text_Items;
with Qt4.Line_Fs;
with Qt4.List_Of_Graphics_Items;
with Qt4.Objects;
with Qt4.Painter_Paths;
with Qt4.Pens;
with Qt4.Point_Fs;
with Qt4.Polygon_Fs;
with Qt4.Rect_Fs;
with Qt4.Strings;
with Qt4.Variants;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Graphics_Scenes is

   type Graphics_Scene_Item_Index_Method is
    (No_Index,
     Bsp_Tree_Index);
   pragma Convention (C, Graphics_Scene_Item_Index_Method);
   for Graphics_Scene_Item_Index_Method use
    (No_Index =>     -16#1#,
     Bsp_Tree_Index =>      16#0#);

   type Q_Graphics_Scene is limited interface
     and Qt4.Objects.Q_Object;

   type Q_Graphics_Scene_Access is
     access all Q_Graphics_Scene'Class;
   for Q_Graphics_Scene_Access'Storage_Size use 0;

   type Q_Graphics_Scene_Pointer is tagged;

   function Add_Ellipse
    (Self : not null access Q_Graphics_Scene'Class;
     Rect : Qt4.Rect_Fs.Q_Rect_F;
     Pen : Qt4.Pens.Q_Pen
       := Qt4.Pens.Create;
     Brush : Qt4.Brushes.Q_Brush
       := Qt4.Brushes.Create)
       return not null access Qt4.Graphics_Ellipse_Items.Q_Graphics_Ellipse_Item'Class;

   procedure Add_Item
    (Self : not null access Q_Graphics_Scene'Class;
     Item : not null access Qt4.Graphics_Items.Q_Graphics_Item'Class);

   function Add_Line
    (Self : not null access Q_Graphics_Scene'Class;
     Line : Qt4.Line_Fs.Q_Line_F;
     Pen : Qt4.Pens.Q_Pen
       := Qt4.Pens.Create)
       return not null access Qt4.Graphics_Line_Items.Q_Graphics_Line_Item'Class;

   function Add_Path
    (Self : not null access Q_Graphics_Scene'Class;
     Path : Qt4.Painter_Paths.Q_Painter_Path;
     Pen : Qt4.Pens.Q_Pen
       := Qt4.Pens.Create;
     Brush : Qt4.Brushes.Q_Brush
       := Qt4.Brushes.Create)
       return not null access Qt4.Graphics_Path_Items.Q_Graphics_Path_Item'Class;

   function Add_Polygon
    (Self : not null access Q_Graphics_Scene'Class;
     Path : Qt4.Polygon_Fs.Q_Polygon_F;
     Pen : Qt4.Pens.Q_Pen
       := Qt4.Pens.Create;
     Brush : Qt4.Brushes.Q_Brush
       := Qt4.Brushes.Create)
       return not null access Qt4.Graphics_Polygon_Items.Q_Graphics_Polygon_Item'Class;

   function Add_Rect
    (Self : not null access Q_Graphics_Scene'Class;
     Path : Qt4.Rect_Fs.Q_Rect_F;
     Pen : Qt4.Pens.Q_Pen
       := Qt4.Pens.Create;
     Brush : Qt4.Brushes.Q_Brush
       := Qt4.Brushes.Create)
       return not null access Qt4.Graphics_Rect_Items.Q_Graphics_Rect_Item'Class;

   function Add_Simple_Text
    (Self : not null access Q_Graphics_Scene'Class;
     Text : Qt4.Strings.Q_String;
     Font : Qt4.Fonts.Q_Font
       := Qt4.Fonts.Create)
       return not null access Qt4.Graphics_Simple_Text_Items.Q_Graphics_Simple_Text_Item'Class;

   function Add_Text
    (Self : not null access Q_Graphics_Scene'Class;
     Text : Qt4.Strings.Q_String;
     Font : Qt4.Fonts.Q_Font
       := Qt4.Fonts.Create)
       return not null access Qt4.Graphics_Text_Items.Q_Graphics_Text_Item'Class;

   function Background_Brush
    (Self : not null access constant Q_Graphics_Scene'Class)
       return Qt4.Brushes.Q_Brush;

   procedure Clear_Focus
    (Self : not null access Q_Graphics_Scene'Class);

   procedure Clear_Selection
    (Self : not null access Q_Graphics_Scene'Class);

   function Focus_Item
    (Self : not null access constant Q_Graphics_Scene'Class)
       return not null access Qt4.Graphics_Items.Q_Graphics_Item'Class;

   function Foreground_Brush
    (Self : not null access constant Q_Graphics_Scene'Class)
       return Qt4.Brushes.Q_Brush;

   function Has_Focus
    (Self : not null access constant Q_Graphics_Scene'Class)
       return Standard.Boolean;

   function Height
    (Self : not null access constant Q_Graphics_Scene'Class)
       return Qt4.Q_Real;

   not overriding
   function Input_Method_Query
    (Self : not null access constant Q_Graphics_Scene;
     Query : Qt4.Input_Method_Query)
       return Qt4.Variants.Q_Variant
         is abstract;

   function Item_At
    (Self : not null access constant Q_Graphics_Scene'Class;
     Pos : Qt4.Point_Fs.Q_Point_F)
       return not null access Qt4.Graphics_Items.Q_Graphics_Item'Class;

   function Item_At
    (Self : not null access constant Q_Graphics_Scene'Class;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real)
       return not null access Qt4.Graphics_Items.Q_Graphics_Item'Class;

   function Item_Index_Method
    (Self : not null access constant Q_Graphics_Scene'Class)
       return Qt4.Graphics_Scenes.Graphics_Scene_Item_Index_Method;

   function Items_Bounding_Rect
    (Self : not null access constant Q_Graphics_Scene'Class)
       return Qt4.Rect_Fs.Q_Rect_F;

   function Mouse_Grabber_Item
    (Self : not null access constant Q_Graphics_Scene'Class)
       return access Qt4.Graphics_Items.Q_Graphics_Item'Class;

   procedure Remove_Item
    (Self : not null access Q_Graphics_Scene'Class;
     Item : not null access Qt4.Graphics_Items.Q_Graphics_Item'Class);

   function Scene_Rect
    (Self : not null access constant Q_Graphics_Scene'Class)
       return Qt4.Rect_Fs.Q_Rect_F;

   procedure Set_Background_Brush
    (Self : not null access Q_Graphics_Scene'Class;
     Brush : Qt4.Brushes.Q_Brush);

   procedure Set_Foreground_Brush
    (Self : not null access Q_Graphics_Scene'Class;
     Brush : Qt4.Brushes.Q_Brush);

   procedure Set_Item_Index_Method
    (Self : not null access Q_Graphics_Scene'Class;
     Method : Qt4.Graphics_Scenes.Graphics_Scene_Item_Index_Method);

   procedure Set_Scene_Rect
    (Self : not null access Q_Graphics_Scene'Class;
     Rect : Qt4.Rect_Fs.Q_Rect_F);

   procedure Set_Scene_Rect
    (Self : not null access Q_Graphics_Scene'Class;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real;
     W : Qt4.Q_Real;
     H : Qt4.Q_Real);

   procedure Set_Selection_Area
    (Self : not null access Q_Graphics_Scene'Class;
     Path : Qt4.Painter_Paths.Q_Painter_Path);

   function Width
    (Self : not null access constant Q_Graphics_Scene'Class)
       return Qt4.Q_Real;

   procedure Advance
    (Self : not null access Q_Graphics_Scene'Class);

   procedure Update
    (Self : not null access Q_Graphics_Scene'Class;
     Rect : Qt4.Rect_Fs.Q_Rect_F
       := Qt4.Rect_Fs.Create);

   function Items (Self : not null access constant Q_Graphics_Scene'Class)
     return Qt4.List_Of_Graphics_Items.Q_List_Of_Q_Graphics_Item;

   procedure Add_Polygon
    (Self  : not null access Q_Graphics_Scene'Class;
     Path  : Qt4.Polygon_Fs.Q_Polygon_F;
     Pen   : Qt4.Pens.Q_Pen := Qt4.Pens.Create;
     Brush : Qt4.Brushes.Q_Brush := Qt4.Brushes.Create);

   package Q_Graphics_Scene_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Graphics_Scene, Q_Graphics_Scene_Access);

   type Q_Graphics_Scene_Pointer is
     new Q_Graphics_Scene_Pointers.Q_Pointer with null record;

end Qt4.Graphics_Scenes;
